

<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>gwmat.domain &mdash; GWMAT: Gravitational Wave Microlensing Analysis Tools 1.0.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=7ab3649f" />

  
      <script src="../../_static/jquery.js?v=5d32c60e"></script>
      <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
      <script src="../../_static/documentation_options.js?v=8d563738"></script>
      <script src="../../_static/doctools.js?v=9a2dae69"></script>
      <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            GWMAT: Gravitational Wave Microlensing Analysis Tools
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../gwmat.html">gwmat package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">GWMAT: Gravitational Wave Microlensing Analysis Tools</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../gwmat.html">gwmat</a></li>
      <li class="breadcrumb-item active">gwmat.domain</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for gwmat.domain</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This module contains the class `CBCParameterDomain`, which provides some</span>
<span class="sd">useful functions to wrap BBH parameters into their respeticve domains.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Anuj Mishra &lt;anuj.mishra@ligo.org&gt;&quot;</span><span class="p">]</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>


<div class="viewcode-block" id="CBCParameterDomain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain">[docs]</a>
<span class="k">class</span> <span class="nc">CBCParameterDomain</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Contains functions to wrap BBH parameters into their respeticve domains.</span>
<span class="sd">    These are mainly used during fitting factor computations.</span>

<span class="sd">    &quot;&quot;&quot;</span>

<div class="viewcode-block" id="CBCParameterDomain.wrap_reflective">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.wrap_reflective">[docs]</a>
    <span class="k">def</span> <span class="nf">wrap_reflective</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to wrap and reflect a real number around the points x1 and x2.</span>
<span class="sd">        Example - For spins, we will have &#39;wrap_reflective(1.1, -1, 1) = 0.9&#39;,</span>
<span class="sd">        &#39;wrap_reflective(-1.1, -1, 1) = -0.9&#39;, and so on.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Value to be reflected.</span>
<span class="sd">        x1 : float</span>
<span class="sd">            The LHS reflective point.</span>
<span class="sd">        x2 : float</span>
<span class="sd">            The RHS reflective point.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Wrapped and reflective value of x around x1 and x2.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="n">x2</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>  <span class="c1"># i.e., x2 can be unbounded</span>
            <span class="n">x2</span> <span class="o">=</span> <span class="p">(</span>
                <span class="mf">1e50</span>  <span class="c1"># assign a big number (but not np.inf as it will bias the algebra)</span>
            <span class="p">)</span>
        <span class="n">period</span> <span class="o">=</span> <span class="mi">2</span> <span class="o">*</span> <span class="p">(</span><span class="n">x2</span> <span class="o">-</span> <span class="n">x1</span><span class="p">)</span>
        <span class="n">x_frac</span> <span class="o">=</span> <span class="p">(</span><span class="n">x</span> <span class="o">-</span> <span class="n">x1</span><span class="p">)</span> <span class="o">%</span> <span class="n">period</span>
        <span class="k">if</span> <span class="n">x_frac</span> <span class="o">&lt;=</span> <span class="n">period</span> <span class="o">/</span> <span class="mi">2</span><span class="p">:</span>
            <span class="n">x_ref</span> <span class="o">=</span> <span class="n">x_frac</span> <span class="o">+</span> <span class="n">x1</span>
        <span class="k">else</span><span class="p">:</span>  <span class="c1"># x_frac &gt; period / 2</span>
            <span class="n">x_ref</span> <span class="o">=</span> <span class="p">(</span><span class="n">period</span> <span class="o">-</span> <span class="n">x_frac</span><span class="p">)</span> <span class="o">+</span> <span class="n">x1</span>
        <span class="k">return</span> <span class="n">x_ref</span></div>


    <span class="c1"># function to wrap a real number periodically around the points x1 and x2.</span>
    <span class="c1"># Ex- for a sine func, we will have &#39;periodic(2*np.pi + x, 0, 2*np.pi) = x&#39;.</span>
<div class="viewcode-block" id="CBCParameterDomain.wrap_periodic">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.wrap_periodic">[docs]</a>
    <span class="k">def</span> <span class="nf">wrap_periodic</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to wrap a real number periodically around the points x1 and x2.</span>
<span class="sd">        Example - For spins, we will have &#39;wrap_periodic(2*np.pi + x, 0, 2*np.pi) = x&#39;.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Value to be reflected.</span>
<span class="sd">        x1 : float</span>
<span class="sd">            The LHS coordinate of boundary.</span>
<span class="sd">        x2 : float</span>
<span class="sd">            The RHS coordinate of boundary.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Periodically wrapped value of x around x1 and x2.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">period</span> <span class="o">=</span> <span class="n">x2</span> <span class="o">-</span> <span class="n">x1</span>
        <span class="n">x_frac</span> <span class="o">=</span> <span class="p">(</span><span class="n">x</span> <span class="o">-</span> <span class="n">x1</span><span class="p">)</span> <span class="o">%</span> <span class="n">period</span>
        <span class="n">x_p</span> <span class="o">=</span> <span class="n">x_frac</span> <span class="o">+</span> <span class="n">x1</span>
        <span class="k">return</span> <span class="n">x_p</span></div>


    <span class="c1"># wraps x between (x1, x2) assuming boundaries to be either periodic or reflective.</span>
<div class="viewcode-block" id="CBCParameterDomain.wrap">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.wrap">[docs]</a>
    <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">,</span> <span class="n">boundary</span><span class="o">=</span><span class="s2">&quot;reflective&quot;</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to wrap a real number around the points</span>
<span class="sd">        x1 and x2 either periodically or reflectively.</span>
<span class="sd">        Example - (i) For spins, we will have</span>
<span class="sd">        &#39;wrap(2*np.pi + x, 0, 2*np.pi, &#39;periodic&#39;) = x&#39;,</span>
<span class="sd">        &#39;wrap(1.1, -1, 1, &#39;reflective&#39;) = 0.9&#39;,</span>
<span class="sd">        &#39;wrap(-1.1, -1, 1, &#39;reflective&#39;) = -0.9&#39;.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Value to be reflected.</span>
<span class="sd">        x1 : float</span>
<span class="sd">            The LHS coordinate of boundary.</span>
<span class="sd">        x2 : float</span>
<span class="sd">            The RHS coordinate of boundary.</span>
<span class="sd">        boundary : {&#39;reflective&#39;, &#39;periodic&#39;}, optional.</span>
<span class="sd">            Boundary type to conisder while wrapping. Default = &#39;reflective&#39;.</span>
<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Periodically wrapped value of x around x1 and x2.</span>

<span class="sd">        Raises</span>
<span class="sd">        ------</span>
<span class="sd">        KeyError</span>
<span class="sd">            Allowed keywords for boundary are: {&#39;reflective&#39;, &#39;periodic&#39;}</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="n">boundary</span> <span class="ow">in</span> <span class="p">(</span><span class="s2">&quot;reflective&quot;</span><span class="p">,</span> <span class="s2">&quot;Reflective&quot;</span><span class="p">):</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap_reflective</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">boundary</span> <span class="ow">in</span> <span class="p">(</span><span class="s2">&quot;periodic&quot;</span><span class="p">,</span> <span class="s2">&quot;Periodic&quot;</span><span class="p">):</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap_periodic</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">)</span>

        <span class="k">raise</span> <span class="ne">KeyError</span><span class="p">(</span>
            <span class="s2">&quot;Incorrect keyword provided for the argument &#39;boundary&#39;.</span><span class="se">\</span>
<span class="s2">            Allowed keywords are: {&#39;reflective&#39;, &#39;periodic&#39;}.&quot;</span>
        <span class="p">)</span></div>


<div class="viewcode-block" id="CBCParameterDomain.check_spin_component_magnitude">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_spin_component_magnitude">[docs]</a>
    <span class="k">def</span> <span class="nf">check_spin_component_magnitude</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Checks if the dimensionless spin magnitude a &lt;  0.998,</span>
<span class="sd">        otherwise assign a = 0.9.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="nb">abs</span><span class="p">(</span><span class="nb">round</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="mi">3</span><span class="p">))</span> <span class="o">&gt;</span> <span class="mf">0.998</span><span class="p">:</span>
            <span class="k">return</span> <span class="mf">0.9</span> <span class="o">*</span> <span class="n">a</span> <span class="o">/</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">a</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">a</span></div>


<div class="viewcode-block" id="CBCParameterDomain.check_spin_component_domain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_spin_component_domain">[docs]</a>
    <span class="k">def</span> <span class="nf">check_spin_component_domain</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Domain of an individual spin component:</span>
<span class="sd">        wrapping and reflection of real line around (-1, 1).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">sp_ref</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.0</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">,</span> <span class="n">boundary</span><span class="o">=</span><span class="s2">&quot;reflective&quot;</span><span class="p">)</span>
        <span class="n">sp_ref</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">check_spin_component_magnitude</span><span class="p">(</span><span class="n">sp_ref</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">sp_ref</span></div>


<div class="viewcode-block" id="CBCParameterDomain.check_total_spin_magnitude">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_total_spin_magnitude">[docs]</a>
    <span class="k">def</span> <span class="nf">check_total_spin_magnitude</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">sp</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Domain of three spin components: ensures that spin magnitude</span>
<span class="sd">        is less than one for a given set of three spin components.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="k">assert</span> <span class="p">(</span>
                <span class="nb">len</span><span class="p">(</span><span class="n">sp</span><span class="p">)</span> <span class="o">==</span> <span class="mi">3</span>
            <span class="p">),</span> <span class="sa">f</span><span class="s2">&quot;Spin should have three components [s_x, s_y, s_z], </span><span class="se">\</span>
<span class="s2">            but entered spin has length = </span><span class="si">{</span><span class="nb">len</span><span class="p">(</span><span class="n">sp</span><span class="p">)</span><span class="si">}</span><span class="s2"> instead&quot;</span>
            <span class="n">sp</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">sp</span><span class="p">)</span>
            <span class="n">a</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linalg</span><span class="o">.</span><span class="n">norm</span><span class="p">([</span><span class="n">sp</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">sp</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">sp</span><span class="p">[</span><span class="mi">2</span><span class="p">]])</span>
            <span class="k">if</span> <span class="n">a</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">a_new</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">check_spin_component_magnitude</span><span class="p">(</span><span class="n">a</span><span class="p">)</span>
                <span class="n">sp</span> <span class="o">=</span> <span class="n">a_new</span> <span class="o">*</span> <span class="n">sp</span> <span class="o">/</span> <span class="n">a</span>
            <span class="k">return</span> <span class="n">sp</span>
        <span class="k">except</span> <span class="ne">TypeError</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">check_spin_component_domain</span><span class="p">(</span><span class="n">sp</span><span class="p">)</span></div>


<div class="viewcode-block" id="CBCParameterDomain.check_spin_vector_domain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_spin_vector_domain">[docs]</a>
    <span class="k">def</span> <span class="nf">check_spin_vector_domain</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">sp</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Final combined function for wrapping of spin values:</span>
<span class="sd">        can handle both 3-component and 1-component spin values.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        sp : {float, list}</span>
<span class="sd">            Spin value(s).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        {float, list}</span>
<span class="sd">            Wrapped spin value(s).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">sp</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">check_spin_component_domain</span><span class="p">,</span> <span class="n">sp</span><span class="p">))</span>
            <span class="n">sp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">check_total_spin_magnitude</span><span class="p">(</span><span class="n">sp</span><span class="p">)</span>
        <span class="k">except</span> <span class="ne">TypeError</span><span class="p">:</span>
            <span class="n">sp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">check_spin_component_domain</span><span class="p">(</span><span class="n">sp</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">sp</span></div>


<div class="viewcode-block" id="CBCParameterDomain.check_mass_domain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_mass_domain">[docs]</a>
    <span class="k">def</span> <span class="nf">check_mass_domain</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">m_min</span><span class="o">=</span><span class="mf">3.5</span><span class="p">,</span> <span class="n">m_max</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns wrapped mass value(s): wrapping and reflection of</span>
<span class="sd">        real line around (3.2, 1e50), where 1e50 is used so that</span>
<span class="sd">        `m &gt; m_min` is the only real restriction.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Mass value to be wrapped within domain.</span>
<span class="sd">        m_min : float, optional</span>
<span class="sd">            Minimum mass to consider while wrapping. Default = 3.5.</span>
<span class="sd">        m_max : {None, float}, optional</span>
<span class="sd">            Maximum mass to consider while wrapping. Default = None.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Wrapped Mass value within domain.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">m_ref</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">m_min</span><span class="p">,</span> <span class="n">m_max</span><span class="p">,</span> <span class="n">boundary</span><span class="o">=</span><span class="s2">&quot;reflective&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">m_ref</span></div>


<div class="viewcode-block" id="CBCParameterDomain.check_chirp_mass_domain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_chirp_mass_domain">[docs]</a>
    <span class="k">def</span> <span class="nf">check_chirp_mass_domain</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">cm_min</span><span class="o">=</span><span class="mf">3.05</span><span class="p">,</span> <span class="n">cm_max</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns wrapped Chirp Mass value(s):</span>
<span class="sd">        wrapping and reflection of real line around (3, 1e50),</span>
<span class="sd">        where 1e50 is a large enough number so that</span>
<span class="sd">        `CM &gt; cm_min` is the only real restriction.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Chirp mass value to be wrapped within domain.</span>
<span class="sd">        cm_min : float, optional</span>
<span class="sd">            Minimum Chirp mass to consider while wrapping.</span>
<span class="sd">            Default = 3.05 (because chirp_mass(m1=3.5, m2=3.5) ~ 3.05).</span>
<span class="sd">        cm_max : {None, float}, optional</span>
<span class="sd">            Maximum Chirp mass to consider while wrapping.</span>
<span class="sd">            Default = None(which uses 1e50 as a proxy).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Wrapped Chirp Mass value within domain.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">cm_ref</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">cm_min</span><span class="p">,</span> <span class="n">cm_max</span><span class="p">,</span> <span class="n">boundary</span><span class="o">=</span><span class="s2">&quot;reflective&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">cm_ref</span></div>


    <span class="c1"># domain of Mass Ratio values: wrapping and reflection of real line around (~0, 1).</span>
<div class="viewcode-block" id="CBCParameterDomain.check_mass_ratio_domain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_mass_ratio_domain">[docs]</a>
    <span class="k">def</span> <span class="nf">check_mass_ratio_domain</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">q_min</span><span class="o">=</span><span class="mi">1</span> <span class="o">/</span> <span class="mf">18.0</span><span class="p">,</span> <span class="n">q_max</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns wrapped mass ratio value(s):</span>
<span class="sd">        wrapping and reflection of real line around (~0, 1),</span>
<span class="sd">        as q = min(m1/m2, m2/m1) lies in (0, 1).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Mass ratio value to be wrapped within domain.</span>
<span class="sd">        q_min : float, optional</span>
<span class="sd">            Minimum mass ratio to consider while wrapping. Default = 3.5.</span>
<span class="sd">        q_max : {None, float}, optional</span>
<span class="sd">            Maximum mass ratio to consider while wrapping. Default = None.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Wrapped mass ratio value within domain.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">x_wrap</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">q_min</span><span class="p">,</span> <span class="n">q_max</span><span class="p">,</span> <span class="n">boundary</span><span class="o">=</span><span class="s2">&quot;reflective&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">x_wrap</span></div>


    <span class="c1"># domain of Symmetric Mass Ratio values: wrapping and reflection of real line around (~0, 1/4).</span>
<div class="viewcode-block" id="CBCParameterDomain.check_symmetric_mass_ratio_domain">
<a class="viewcode-back" href="../../gwmat.html#gwmat.domain.CBCParameterDomain.check_symmetric_mass_ratio_domain">[docs]</a>
    <span class="k">def</span> <span class="nf">check_symmetric_mass_ratio_domain</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">eta_min</span><span class="o">=</span><span class="mf">0.05</span><span class="p">,</span> <span class="n">eta_max</span><span class="o">=</span><span class="mi">1</span> <span class="o">/</span> <span class="mf">4.0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns wrapped symmetric mass ratio value(s):</span>
<span class="sd">        wrapping and reflection of real line around (~0, 1/4.).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : float</span>
<span class="sd">            Mass ratio value to be wrapped within domain.</span>
<span class="sd">        eta_min : float, optional</span>
<span class="sd">            Minimum symmetric mass ratio to consider while wrapping. Default = 3.5.</span>
<span class="sd">        eta_max : {None, float}, optional</span>
<span class="sd">            Maximum symmetric mass ratio to consider while wrapping. Default = None.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Wrapped symmetric mass ratio value within domain.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">x_wrap</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">wrap</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">eta_min</span><span class="p">,</span> <span class="n">eta_max</span><span class="p">,</span> <span class="n">boundary</span><span class="o">=</span><span class="s2">&quot;reflective&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">x_wrap</span></div>
</div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Anuj Mishra.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>